// Zoom Ontop Fix
// Copyright (C) 2017 Philippe Troin <phil@fifi.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// You need both xdotool and xwininfo installed

const Main = imports.ui.main;

let _handlerid;

function _onWindowCreated(display, window) {
    let wclass = window.get_wm_class();
    let title = window.get_title();
    if (wclass === 'zoom' && (title === 'zoom_linux_float_video_window' || title === 'as_toolbar')) {
	Main.Util.spawn(['sh', '-c',
			 "xwininfo -root -tree | egrep '^[[:space:]]*0x[a-f0-9]+[[:space:]]+\""+title+"\":[[:space:]]' | sed -e 's!^[[:space:]]*!!' -e 's![[:space:]].*$!!' | xargs -rn 1 xdotool windowraise" ]);
	log('Zoom_Ontop_Fix@fifi.org: Raised wm_class="'+wclass+'" wm_title="'+title+'"');
    }
}

function init() {
    _handlerid = null;
}

function enable() {
    disable();
    _handlerid = global.display.connect('window-created', _onWindowCreated);
}

function disable() {
    if (_handlerid !== null) {
	global.display.disconnect(_handlerid);
    }
    _handlerid = null;
}
